/**************************************************************************//**
 * lpcSYSCON.h - definitions of bitfields in SYSCON module in LPC13xx
 ******************************************************************************/

#ifndef _LPC13xx_SYSON_HEADER_FILE_
  #define _LPC13xx_SYSCON_HEADER_FILE_

/* --- SYSCON --- */
#define SYSCON_MEMREMAP_MASK_MAP              0x03
#define SYSCON_MEMREMAP_MAP_BOOTLOADER        0x00
#define SYSCON_MEMREMAP_MAP_RAM               0x01
#define SYSCON_MEMREMAP_MAP_FLASH             0x02

#define SYSCON_PRESETCTRL_SSP_RST_N           0x01
#define SYSCON_PRESETCTRL_I2C_RST_N           0x02
#define SYSCON_PRESETCTRL_SSP1_RST_N          0x04

#define SYSCON_SYSPLLCTRL_MASK_MSEL           0x1F
#define SYSCON_SYSPLLCTRL_SHIFT_MSEL          0
#define SYSCON_SYSPLLCTRL_MASK_PSEL           0x60
#define SYSCON_SYSPLLCTRL_SHIFT_PSEL          5

#define SYSCON_SYSPLLSTAT_MASK_LOCK           0x01

#define SYSCON_USBPLLCTRL_MASK_MSEL           0x1F
#define SYSCON_USBPLLCTRL_SHIFT_MSEL          0
#define SYSCON_USBPLLCTRL_MASK_PSEL           0x60
#define SYSCON_USBPLLCTRL_SHIFT_PSEL          5

#define SYSCON_USBPLLSTAT_MASK_LOCK           0x01

#define SYSCON_SYSOSCCTRL_OSC_BYPASSED        0x01
#define SYSCON_SYSOSCCTRL_FREQRANGE_1_20MHZ   0x00
#define SYSCON_SYSOSCCTRL_FREQRANGE_15_25MHZ  0x02

#define SYSCON_WDTOSCCTRL_MASK_DIVSEL         0x01F
#define SYSCON_WDTOSCCTRL_SHIFT_DIVSEL        0
#define SYSCON_WDTOSCCTRL_MASK_FREQSEL        0x1E0
#define SYSCON_WDTOSCCTRL_SHIFT_FREQSEL       5
#define SYSCON_WDTOSCCTRL_FREQSEL_0_6MHZ      1
#define SYSCON_WDTOSCCTRL_FREQSEL_1_05MHZ     2
#define SYSCON_WDTOSCCTRL_FREQSEL_1_4MHZ      3
#define SYSCON_WDTOSCCTRL_FREQSEL_1_75MHZ     4
#define SYSCON_WDTOSCCTRL_FREQSEL_2_1MHZ      5
#define SYSCON_WDTOSCCTRL_FREQSEL_2_4MHZ      6
#define SYSCON_WDTOSCCTRL_FREQSEL_2_7MHZ      7
#define SYSCON_WDTOSCCTRL_FREQSEL_3_0MHZ      8
#define SYSCON_WDTOSCCTRL_FREQSEL_3_25MHZ     9
#define SYSCON_WDTOSCCTRL_FREQSEL_3_5MHZ      10
#define SYSCON_WDTOSCCTRL_FREQSEL_3_75MHZ     11
#define SYSCON_WDTOSCCTRL_FREQSEL_4_0MHZ      12
#define SYSCON_WDTOSCCTRL_FREQSEL_4_2MHZ      13
#define SYSCON_WDTOSCCTRL_FREQSEL_4_4MHZ      14
#define SYSCON_WDTOSCCTRL_FREQSEL_4_6MHZ      15

#define SYSCON_IRCCTRL_MASK_TRIM              0xFF

#define SYSCON_SYSRSTSTAT_POR                 0x01
#define SYSCON_SYSRSTSTAT_EXTRST              0x02
#define SYSCON_SYSRSTSTAT_WDT                 0x04
#define SYSCON_SYSRSTSTAT_BOD                 0x08
#define SYSCON_SYSRSTSTAT_SYSRST              0x10

#define SYSCON_SYSPLLCLKSEL_MASK_SEL          0x03
#define SYSCON_SYSPLLCLKSEL_SEL_IRC           0x00
#define SYSCON_SYSPLLCLKSEL_SEL_SYSOSC        0x01

#define SYSCON_SYSPLLCLKUEN_ENA               0x01

#define SYSCON_USBPLLCLKSEL_MASK_SEL          0x03
#define SYSCON_USBPLLCLKSEL_SEL_IRC           0x00
#define SYSCON_USBPLLCLKSEL_SEL_SYSOSC        0x01

#define SYSCON_USBPLLCLKUEN_ENA               0x01

#define SYSCON_MAINCLKSEL_MASK_SEL            0x03
#define SYSCON_MAINCLKSEL_SEL_IRC             0x00
#define SYSCON_MAINCLKSEL_SEL_PLLIN           0x01
#define SYSCON_MAINCLKSEL_SEL_WDTOSC          0x02
#define SYSCON_MAINCLKSEL_SEL_PLLOUT          0x03

#define SYSCON_MAINCLKUEN_ENA                 0x01

#define SYSCON_SYSAHBCLKDIV_MASK_DIV          0xFF

#define SYSCON_SYSAHBCLKCTRL_SYS              0x00000001
#define SYSCON_SYSAHBCLKCTRL_ROM              0x00000002
#define SYSCON_SYSAHBCLKCTRL_RAM              0x00000004
#define SYSCON_SYSAHBCLKCTRL_FLASHREG         0x00000008
#define SYSCON_SYSAHBCLKCTRL_FLASHARR         0x00000010
#define SYSCON_SYSAHBCLKCTRL_I2C              0x00000020
#define SYSCON_SYSAHBCLKCTRL_GPIO             0x00000040
#define SYSCON_SYSAHBCLKCTRL_CT16B0           0x00000080
#define SYSCON_SYSAHBCLKCTRL_CT16B1           0x00000100
#define SYSCON_SYSAHBCLKCTRL_CT32B0           0x00000200
#define SYSCON_SYSAHBCLKCTRL_CT32B1           0x00000400
#define SYSCON_SYSAHBCLKCTRL_SSP              0x00000800
#define SYSCON_SYSAHBCLKCTRL_UART             0x00001000
#define SYSCON_SYSAHBCLKCTRL_ADC              0x00002000
#define SYSCON_SYSAHBCLKCTRL_USBREG           0x00004000
#define SYSCON_SYSAHBCLKCTRL_WDT              0x00008000
#define SYSCON_SYSAHBCLKCTRL_IOCON            0x00010000
#define SYSCON_SYSAHBCLKCTRL_SSP1             0x00040000

#define SYSCON_SSPCLKDIV_MASK_DIV             0xFF

#define SYSCON_UARTCLKDIV_MASK_DIV            0xFF

#define SYSCON_SSP1CLKDIV_MASK_DIV            0xFF

#define SYSCON_TRACECLKDIV_MASK_DIV           0xFF

#define SYSCON_SYSTICKCLKDIV_MASK_DIV         0xFF

#define SYSCON_USBCLKSEL_MASK_SEL             0x03
#define SYSCON_USBCLKSEL_SEL_USBPLL           0x00
#define SYSCON_USBCLKSEL_SEL_MAINCLK          0x01

#define SYSCON_USBCLKUEN_ENA                  0x01

#define SYSCON_USBCLKDIV_MASK_DIV             0xFF

#define SYSCON_WDTCLKSEL_MASK_SEL             0x03
#define SYSCON_WDTCLKSEL_SEL_IRC              0x00
#define SYSCON_WDTCLKSEL_SEL_MAINCLK          0x01
#define SYSCON_WDTCLKSEL_SEL_WDTOSC           0x02

#define SYSCON_WDTCLKUEN_ENA                  0x01

#define SYSCON_WDTCLKDIV_MASK_DIV             0xFF

#define SYSCON_CLKOUTCLKSEL_MASK_SEL          0x03
#define SYSCON_CLKOUTCLKSEL_SEL_IRC           0x00
#define SYSCON_CLKOUTCLKSEL_SEL_SYSOSC        0x01
#define SYSCON_CLKOUTCLKSEL_SEL_WDTOSC        0x02
#define SYSCON_CLKOUTCLKSEL_SEL_MAINCLK       0x03

#define SYSCON_CLKOUTUEN_ENA                  0x01

#define SYSCON_CLKOUTDIV_MASK_DIV             0xFF

#define SYSCON_PIOPORCAP0_PIO0_0              0x00000001
#define SYSCON_PIOPORCAP0_PIO0_1              0x00000002
#define SYSCON_PIOPORCAP0_PIO0_2              0x00000004
#define SYSCON_PIOPORCAP0_PIO0_3              0x00000008
#define SYSCON_PIOPORCAP0_PIO0_4              0x00000010
#define SYSCON_PIOPORCAP0_PIO0_5              0x00000020
#define SYSCON_PIOPORCAP0_PIO0_6              0x00000040
#define SYSCON_PIOPORCAP0_PIO0_7              0x00000080
#define SYSCON_PIOPORCAP0_PIO0_8              0x00000100
#define SYSCON_PIOPORCAP0_PIO0_9              0x00000200
#define SYSCON_PIOPORCAP0_PIO0_10             0x00000400
#define SYSCON_PIOPORCAP0_PIO0_11             0x00000800
#define SYSCON_PIOPORCAP0_PIO1_0              0x00001000
#define SYSCON_PIOPORCAP0_PIO1_1              0x00002000
#define SYSCON_PIOPORCAP0_PIO1_2              0x00004000
#define SYSCON_PIOPORCAP0_PIO1_3              0x00008000
#define SYSCON_PIOPORCAP0_PIO1_4              0x00010000
#define SYSCON_PIOPORCAP0_PIO1_5              0x00020000
#define SYSCON_PIOPORCAP0_PIO1_6              0x00040000
#define SYSCON_PIOPORCAP0_PIO1_7              0x00080000
#define SYSCON_PIOPORCAP0_PIO1_8              0x00100000
#define SYSCON_PIOPORCAP0_PIO1_9              0x00200000
#define SYSCON_PIOPORCAP0_PIO1_10             0x00400000
#define SYSCON_PIOPORCAP0_PIO1_11             0x00800000
#define SYSCON_PIOPORCAP0_PIO2_0              0x01000000
#define SYSCON_PIOPORCAP0_PIO2_1              0x02000000
#define SYSCON_PIOPORCAP0_PIO2_2              0x04000000
#define SYSCON_PIOPORCAP0_PIO2_3              0x08000000
#define SYSCON_PIOPORCAP0_PIO2_4              0x10000000
#define SYSCON_PIOPORCAP0_PIO2_5              0x20000000
#define SYSCON_PIOPORCAP0_PIO2_6              0x40000000
#define SYSCON_PIOPORCAP0_PIO2_7              0x80000000

#define SYSCON_PIOPORCAP1_PIO2_8              0x00000001
#define SYSCON_PIOPORCAP1_PIO2_9              0x00000002
#define SYSCON_PIOPORCAP1_PIO2_10             0x00000004
#define SYSCON_PIOPORCAP1_PIO2_11             0x00000008
#define SYSCON_PIOPORCAP1_PIO3_0              0x00000010
#define SYSCON_PIOPORCAP1_PIO3_1              0x00000020
#define SYSCON_PIOPORCAP1_PIO3_2              0x00000040
#define SYSCON_PIOPORCAP1_PIO3_3              0x00000080
#define SYSCON_PIOPORCAP1_PIO3_4              0x00000100
#define SYSCON_PIOPORCAP1_PIO3_5              0x00000200

#define SYSCON_BODCTRL_MASK_BODRSTLEV         0x03
#define SYSCON_BODCTRL_SHIFT_BODRSTLEV        0
#define SYSCON_BODCTRL_MASK_BODINTVAL         0x0C
#define SYSCON_BODCTRL_SHIFT_BODINTVAL        2
#define SYSCON_BODCTRL_BODRSTENA              0x10

#define SYSCON_SYSTCKCAL_MASK_CAL             0x03FFFFFF

#define SYSCON_STARTAPRP0_MASK_APRPIO0        0x00000FFF
#define SYSCON_STARTAPRP0_SHIFT_APRPIO0       0
#define SYSCON_STARTAPRP0_MASK_APRPIO1        0x00FFF000
#define SYSCON_STARTAPRP0_SHIFT_APRPIO1       12
#define SYSCON_STARTAPRP0_MASK_APRPIO2        0xFF000000
#define SYSCON_STARTAPRP0_SHIFT_APRPIO2       24

#define SYSCON_STARTERP0_MASK_ERPIO0          0x00000FFF
#define SYSCON_STARTERP0_SHIFT_ERPIO0         0
#define SYSCON_STARTERP0_MASK_ERPIO1          0x00FFF000
#define SYSCON_STARTERP0_SHIFT_ERPIO1         12
#define SYSCON_STARTERP0_MASK_ERPIO2          0xFF000000
#define SYSCON_STARTERP0_SHIFT_ERPIO2         24

#define SYSCON_STARTRSRP0CLR_MASK_RSRPIO0     0x00000FFF
#define SYSCON_STARTRSRP0CLR_SHIFT_RSRPIO0    0
#define SYSCON_STARTRSRP0CLR_MASK_RSRPIO1     0x00FFF000
#define SYSCON_STARTRSRP0CLR_SHIFT_RSRPIO1    12
#define SYSCON_STARTRSRP0CLR_MASK_RSRPIO2     0xFF000000
#define SYSCON_STARTRSRP0CLR_SHIFT_RSRPIO2    24

#define SYSCON_STARTSRP0_MASK_SRPIO0          0x00000FFF
#define SYSCON_STARTSRP0_SHIFT_SRPIO0         0
#define SYSCON_STARTSRP0_MASK_SRPIO1          0x00FFF000
#define SYSCON_STARTSRP0_SHIFT_SRPIO1         12
#define SYSCON_STARTSRP0_MASK_SRPIO2          0xFF000000
#define SYSCON_STARTSRP0_SHIFT_SRPIO2         24

#define SYSCON_STARTAPRP1_MASK_APRPIO2        0x0000000F
#define SYSCON_STARTAPRP1_SHIFT_APRPIO2       0
#define SYSCON_STARTAPRP1_MASK_APRPIO3        0x000000F0
#define SYSCON_STARTAPRP1_SHIFT_APRPIO3       4

#define SYSCON_STARTERP1_MASK_ERPIO2          0x0000000F
#define SYSCON_STARTERP1_SHIFT_ERPIO2         0
#define SYSCON_STARTERP1_MASK_ERPIO3          0x000000F0
#define SYSCON_STARTERP1_SHIFT_ERPIO3         4

#define SYSCON_STARTRSRP1CLR_MASK_RSRPIO2     0x0000000F
#define SYSCON_STARTRSRP1CLR_SHIFT_RSRPIO2    0
#define SYSCON_STARTRSRP1CLR_MASK_RSRPIO3     0x000000F0
#define SYSCON_STARTRSRP1CLR_SHIFT_RSRPIO3    4

#define SYSCON_STARTSRP1_MASK_SRPIO2          0x0000000F
#define SYSCON_STARTSRP1_SHIFT_SRPIO2         0
#define SYSCON_STARTSRP1_MASK_SRPIO3          0x000000F0
#define SYSCON_STARTSRP1_SHIFT_SRPIO3         4

#define SYSCON_PDSLEEPCFG_FIXEDVAL0           0x0007
#define SYSCON_PDSLEEPCFG_BOD_PD              0x0008
#define SYSCON_PDSLEEPCFG_FIXEDVAL1           0x0030
#define SYSCON_PDSLEEPCFG_WDTOSC_PD           0x0040
#define SYSCON_PDSLEEPCFG_FIXEDVAL2_LPC1300   0x0F80
#define SYSCON_PDSLEEPCFG_FIXEDVAL2_LPC1300L  0x1880

#define SYSCON_PDAWAKECFG_IRCOUT_PD           0x00000001
#define SYSCON_PDAWAKECFG_IRC_PD              0x00000002
#define SYSCON_PDAWAKECFG_FLASH_PD            0x00000004
#define SYSCON_PDAWAKECFG_BOD_PD              0x00000008
#define SYSCON_PDAWAKECFG_ADC_PD              0x00000010
#define SYSCON_PDAWAKECFG_SYSOSC_PD           0x00000020
#define SYSCON_PDAWAKECFG_WDTOSC_PD           0x00000040
#define SYSCON_PDAWAKECFG_SYSPLL_PD           0x00000080
#define SYSCON_PDAWAKECFG_USBPLL_PD           0x00000100
#define SYSCON_PDAWAKECFG_FIXEDVAL0           0x00000000
#define SYSCON_PDAWAKECFG_USBPAD_PD           0x00000400
#define SYSCON_PDAWAKECFG_FIXEDVAL1           0x00000800
#define SYSCON_PDAWAKECFG_FIXEDVAL2           0x00000000
#define SYSCON_PDAWAKECFG_FIXEDVAL3           0x0000E000

#define SYSCON_PDRUNCFG_IRCOUT_PD             0x00000001
#define SYSCON_PDRUNCFG_IRC_PD                0x00000002
#define SYSCON_PDRUNCFG_FLASH_PD              0x00000004
#define SYSCON_PDRUNCFG_BOD_PD                0x00000008
#define SYSCON_PDRUNCFG_ADC_PD                0x00000010
#define SYSCON_PDRUNCFG_SYSOSC_PD             0x00000020
#define SYSCON_PDRUNCFG_WDTOSC_PD             0x00000040
#define SYSCON_PDRUNCFG_SYSPLL_PD             0x00000080
#define SYSCON_PDRUNCFG_USBPLL_PD             0x00000100
#define SYSCON_PDRUNCFG_FIXEDVAL0             0x00000000
#define SYSCON_PDRUNCFG_USBPAD_PD             0x00000400
#define SYSCON_PDRUNCFG_FIXEDVAL1             0x00000800
#define SYSCON_PDRUNCFG_FIXEDVAL2             0x00000000
#define SYSCON_PDRUNCFG_FIXEDVAL3             0x0000E000


#endif /* _LPC13xx_SYSCON_HEADER_FILE_ */
